      SUBROUTINE QSF2R(INT1,INT2,A,B,F,RO,FI,E,L1,L2)
      DIMENSION G(5),L(5),M(5),Q1(5),BC(7)
      INTEGER L1,L2,D
      REAL INT1,INT2,A,B,F,RO,FI,E,G,L,M,Q1,BC,I,K,C,W,Z2,
     1EPS,H,Z1,P,R,Q,V,T,S,U,Z,BA,BB,BD,X,Y,SIN,COS,ABS,
     1AMAX1,TDS,TSO,TOF,FLOAT,HMIN
      LOGICAL NI
      DATA  TDS/.2666666/,TSO/.7111111/,TOF/.1555555/
      DATA SYS051/1.192093E-7/
      DATA HMIN/1.192093E-4/
      NI=A.GT.B
      IF(.NOT.(NI)) GO TO 1
      C=A
      A=B
      B=C
    1 W=B-A
      IF(.NOT.(W.EQ.0.)) GO TO 2
      INT1=0.
      INT2=0.
      GO TO 21
    2 Z2=E/W
      EPS=ABS(E)
      H=1.
      Z1=EPS/W
      P=0.
      INT1=0.
      INT2=0.
    3 R=H/2.
      Q=W*R
      V=Q*RO
      T=H*.25
      DO 4 D=1,5
      L(D)=F(A+W*(P+T*FLOAT(D-1)))
    4 CONTINUE
    5 IF((L1+L2).LT.1.5.AND.V.LE..25) GO TO 6
      S=ABS(L(1)+L(5)-4.*(L(2)+L(4))+6.*L(3))
      GO TO 8
    6 I=(A+W*(P+R))*RO+FI
      DO 7 D=1,5
      M(D)=L(D)*SIN(I)
      Q1(D)=L(D)*COS(I)
    7 CONTINUE
      I=M(1)+M(5)-4.*(M(2)+M(4))+6.*M(3)
      S=Q1(1)+Q1(5)-4.*(Q1(2)+Q1(4))+6.*Q1(3)
      S=AMAX1(FLOAT(L1)*ABS(I),FLOAT(L2)*ABS(S))
    8 S=S*R*.42
      IF(H.LT.HMIN) GO TO 22
      IF(ABS(S)-Z1) 12,9,9
    9 H=H/2
      IF(H-SYS051*P) 22,22,11
   11 L(5)=L(3)
      L(3)=L(2)
      R=H*.5
      V=W*R*RO
      T=H*.25
      U=P+T
      L(2)=F(A+W*U)
      L(4)=F(A+W*(U+R))
      GO TO 5
   12 I=(A+W*(P+R))*RO+FI
      Z=SIN(I)
      BA=COS(I)
      Q=W*R
      BB=RO*Q
      BC(4)=SIN(BB)
      BC(5)=COS(BB)
      IF(BB-0.33) 13,13,14
   13 BD=BB*0.5
      BC(6)=SIN(BD)
      BC(7)=COS(BD)
      G(1)=TDS
      G(2)=TSO*BC(7)
      G(3)=TOF*BC(5)
      G(4)=TSO*BC(6)
      G(5)=TOF*BC(4)
      GO TO 15
   14 BC(1)=1./BB
      BC(2)=BC(1)*BC(1)
      BC(3)=BC(2)*BC(2)
      G(1)=4.*BC(2)*(BC(1)*(48.*BC(2)-19.)*BC(4)+3.*(1.-16.*
     1BC(2))*BC(5))
      G(2)=32.*BC(2)*(BC(1)*(5.-12.*BC(2))*BC(4)-(1.-12.*
     1BC(2))*BC(5))/3.
      G(3)=BC(1)*((3.-46.*BC(2)+96.*BC(3))*BC(4)+2.*BC(1)*
     1(7.-48.*BC(2))*BC(5))/3.
      G(4)=-16.*BC(2)*((1.-3.*BC(2))*BC(4)+3.*BC(1)*BC(5))/
     13.
      G(5)=BC(1)*(BC(1)*(11.-24.*BC(2))*BC(4)-3.*(1.-8.*
     1BC(2))*BC(5))/3.
   15 X=G(1)*L(3)+G(2)*(L(2)+L(4))+G(3)*(L(1)+L(5))
      Y=G(4)*(L(4)-L(2))+G(5)*(L(5)-L(1))
      R1=(Z*X+BA*Y)*R
      R2=(BA*X-Z*Y)*R
      INT1=INT1+R1
      INT2=INT2+R2
      IF(P.EQ.P+H) GO TO 22
      P=P+H
      K=1.-P
      IF(K.LE.0) GO TO 20
   16 L(1)=L(5)
      IF(ABS(S)-Z1/32.) 17,18,18
   17 H=2*H
   18 IF(H-K) 3,3,19
   19 H=K
      GO TO 3
   22 IERR=65
      CALL UTQS10(IERR,13) 
   20 INT1=INT1*W
      INT2=INT2*W
      IF(.NOT.(NI)) GO TO 21
      C=B
      B=A
      A=C
   21 RETURN
      END
